stages:
  - deploydev
  - test
  - deployprod

Deploy to openshift dev:
  stage: deploydev
  tags:
    - tsystems-openshift
  image: openshift/origin-cli
  #image: mtr.external.otc.telekomcloud.com/tcpq/openshift-client
  script:
    - oc login https://openshift.devops.t-systems.ru:8443 --insecure-skip-tls-verify --username=$OC_USER --password=$OC_PWD --namespace=coursework
    - cat db-statefulset.yml | sed "s/esmirnova\/tchallenge_mongo:latest/esmirnova\/tchallenge_mongo:$DB_TAG/g" > db-statefulset-tagged.yml
    - oc apply -f db-statefulset-tagged.yml
    - cat service-deployment.yml | sed "s/esmirnova\/tchallenge_service:latest/esmirnova\/tchallenge_service:$SERVICE_TAG/g" > service-deployment-tagged.yml
    - oc apply -f service-deployment-tagged.yml
    - oc apply -f service-route-dev.yml
    - cat participant-deployment-dev.yml | sed "s/tchallenge_participant:latest/tchallenge_participant:$PARTICIPANT_TAG/g" > participant-deployment-dev-tagged.yml
    - oc apply -f participant-deployment-dev-tagged.yml
    - oc apply -f participant-route-dev.yml
  artifacts:
    paths:
      - db-statefulset-tagged.yml
      - service-deployment-tagged.yml
    expire_in: 1 hour

Test:
  stage: test
  tags:
    - tsystems-openshift
  image: curlimages/curl:7.78.0
  script:
    - echo Testing the backend
    - 'curl -d "@request.json" -X POST -H "Content-Type: application/json" -s http://service-service-coursework.openshift.devops.t-systems.ru/security/tokens/ | tee response.json'
    - if [ -s response.json ];then echo service test passed; else echo service test failed, no response; exit 1; fi
    - echo Testing the frontend
    - curl -X GET -s http://participant-service-coursework.openshift.devops.t-systems.ru | tee response.html
    - if [ -s response.html ];then echo participant test passed; else echo participant test failed, no response; exit 1; fi
  artifacts:
    paths:
      - response.json
      - response.html
    expire_in: 1 day

Prod:
  stage: deployprod
  when: manual
  tags:
      - tsystems-openshift
  image: openshift/origin-cli
  script:
        - oc login https://openshift.devops.t-systems.ru:8443 --insecure-skip-tls-verify --username=$OC_USER --password=$OC_PWD --namespace=courseworkprod
        - if [ $DB_TAG != "latest" ] ; then oc apply -f db-statefulset-tagged.yml; fi
        - if [ $SERVICE_TAG != "latest" ] ; then oc apply -f service-deployment-tagged.yml; oc apply -f service-route-prod.yml; fi
        - if [ $PARTICIPANT_TAG != "latest" ] ; then cat participant-deployment-prod.yml | sed "s/esmirnova\/tchallenge_participant:latest/esmirnova\/tchallenge_participant:$PARTICIPANT_TAG/g" > participant-deployment-prod-tagged.yml; oc apply -f participant-deployment-prod-tagged.yml; oc apply -f participant-route-prod.yml; fi
